--- ./src/src/log.c	2018-09-26 15:58:49.000000000 +0500
+++ ./src/src/log.c_p	2018-10-01 00:20:12.000000000 +0500
@@ -19,7 +19,7 @@
 
 enum { lt_main, lt_reject, lt_panic, lt_debug };
 
-static uschar *log_names[] = { US"main", US"reject", US"panic", US"debug" };
+static uschar *log_names[] = { US"cee", US"main", US"reject", US"panic", US"debug" };
 
 
 
@@ -863,6 +863,7 @@
     }
 
   ptr += sprintf(CS ptr, "%s%s%s%s\n  ",
+    ((flags & LOG_CEE) != 0)?    " CEE"   : "",
     ((flags & LOG_MAIN) != 0)?    " MAIN"   : "",
     ((flags & LOG_PANIC) != 0)?   " PANIC"  : "",
     ((flags & LOG_PANIC_DIE) == LOG_PANIC_DIE)? " DIE" : "",
@@ -882,7 +883,7 @@
 
 /* If no log file is specified, we are in a mess. */
 
-if ((flags & (LOG_MAIN|LOG_PANIC|LOG_REJECT)) == 0)
+if ((flags & (LOG_CEE|LOG_MAIN|LOG_PANIC|LOG_REJECT)) == 0)
   log_write(0, LOG_MAIN|LOG_PANIC_DIE, "log_write called with no log "
     "flags set");
 
@@ -912,14 +913,17 @@
   }
 
 if (really_exim && message_id[0] != 0)
-  ptr += sprintf(CS ptr, "%s ", message_id);
-
-if ((flags & LOG_CONFIG) != 0) ptr = log_config_info(ptr, flags);
+  if ((flags & LOG_CEE) == 0)
+    {
+      sprintf(CS ptr, "%s ", message_id);
+      ptr += sprintf(CS ptr, "%s ", message_id);
 
-va_start(ap, format);
-if (!string_vformat(ptr, LOG_BUFFER_SIZE - (ptr-log_buffer)-1, format, ap))
-  Ustrcpy(ptr, "**** log string overflowed log buffer ****\n");
-while(*ptr) ptr++;
+      if ((flags & LOG_CONFIG) != 0) ptr = log_config_info(ptr, flags);
+      va_start(ap, format);
+      if (!string_vformat(ptr, LOG_BUFFER_SIZE - (ptr-log_buffer)-1, format, ap))
+        Ustrcpy(ptr, "**** log string overflowed log buffer ****\n");
+      while(*ptr) ptr++;
+    }
 va_end(ap);
 
 /* Add the raw, unrewritten, sender to the message if required. This is done
@@ -973,7 +977,7 @@
 has been renamed. Therefore, do a stat() and see if the inode has changed, and
 if so, re-open. */
 
-if (  flags & LOG_MAIN
+if (  flags & (LOG_CEE|LOG_MAIN)
    && (!selector ||  selector & log_selector[0]))
   {
   if (  logging_mode & LOG_MODE_SYSLOG
